$background-color: #1b1d26;
$background-color-dark: #0f1117;
$link-color: #f5d47a;

$table-row-zebra: #21242f;

$table-row-clickable-background-hover: #282b39;
$table-row-editing: #386695;

$text-color-error: #e25353;
$text-color-dark: #48596f;
$text-color-med: #89a0bf;
$text-color-light: #c7d7ef;
$text-color-white: #f7fbff;

$border-color: #354253;

$site-color: #89a0bf;
$input-background: #60728b;
$input-background-disabled: #2f3a4b;
$input-background-hover: #6b7f9a;

$border-radius: 4px;

body {
  font-family: -apple-system, BlinkMacSystemFont, "Segoe UI", Roboto, Helvetica, Arial, sans-serif;
  overflow-y: scroll;
}

* {
  -webkit-box-sizing: border-box;
  -moz-box-sizing: border-box;
  box-sizing: border-box;
  //font-family: ".SF NS Mono",monospace;
}

html, body {
  min-height: 100vh;
  padding: 0;
  margin: 0;
  background-color: $background-color;
}

h1 {
  color: $text-color-med;
  font-weight: 400;
  margin-top: 0;

  strong {
    color: $text-color-white;
  }
}

h1.display-1 {
  color: $text-color-white;
}

h2 {
  color: #89a0bf;
}

h4 {
  color: $text-color-dark;
}

p {
  color: #89a0bf;

  &.error {
    color: $text-color-error;
  }

  &.info {
    font-size: 10pt;
  }
}

small {
  font-weight: bolder;
  color: $input-background-hover;
}

input, textarea {
  background-color: $input-background;
  border: none;
  padding: 4px 8px;
  outline: none;
  color: #ddd;
  border-radius: $border-radius;
  font-size: 11pt;
  caret-color: $link-color;

  &:disabled {
    background-color: $input-background-disabled;
  }

  &.optional {
    background-color: $input-background-disabled;
  }

  &.code {
    background-color: $input-background-disabled;

    &:hover {
      background-color: $input-background-disabled;
    }
  }

  &.error {
    background-color: $text-color-error;
  }
}


button {
  border-radius: $border-radius;
  background-color: $input-background;
  border: none;
  padding: 4px 8px;
  outline: none;
  color: $text-color-light;

  &:disabled {
    cursor: default;
    background-color: $input-background-disabled;
    color: $text-color-dark;
  }

  &:hover:not([disabled]) {
    cursor: pointer;
    background-color: $input-background-hover;
    color: $text-color-white;
  }

}


::placeholder { /* Chrome, Firefox, Opera, Safari 10.1+ */
  color: $text-color-med;
  opacity: 1; /* Firefox */
}

:-ms-input-placeholder { /* Internet Explorer 10-11 */
  color: $text-color-med;
}

::-ms-input-placeholder { /* Microsoft Edge */
  color: $text-color-med;
}

table input:hover, table input:focus {
  border-radius: 0;
  background-color: #60728b;

}

table {
  border-collapse: collapse;
  min-width: 100%;
}

th {
  padding: 4px 8px;
  margin: 0;
  text-align: left;

  &.action {
    text-align: center;
  }

  i {
    color: $text-color-dark;
  }
}

tr, td {
  padding: 0;
  margin: 0;
}

td.padded {
  padding: 4px 8px;
}

th {
  background-color: $background-color-dark;
  color: $text-color-light;
  font-size: 12pt;
}

td {
  color: $text-color-white;
  font-size: 11pt;
}

td input {
  background-color: transparent;
  min-width: 100%;
}

tr.zebra:nth-of-type(odd) {
  background-color: $table-row-zebra;
}

table#smart-table-element > tr:hover, table#smart-table-element > tr.zebra:nth-of-type(odd):hover {
  background-color: #282b39;
}

table#smart-table-element > tr.editing {
  background-color: $table-row-editing;
}

table#smart-table-element > tr.deleting {
  background-color: #e05125;
}

input:hover {
  background-color: $input-background-hover;

  &.error {
    background-color: $text-color-error;
  }
}

input[type=file] {
  padding: 0 8px 0 0;
}


input[type=submit]:hover {
  cursor: pointer;
  background-color: $input-background-hover;

  &.error {
    background-color: $text-color-error;
  }
}

a {
  color: $link-color;
}

.container {
  padding: 2em;
}

/* ------
//flex-flow: <‘flex-direction’> || <‘flex-wrap’>;
//flex-direction: row | row-reverse | column | column-reverse;
//flex-wrap: nowrap | wrap | wrap-reverse;
//justify-content: flex-start | flex-end | center | space-between | space-around | space-evenly;
//align-items: stretch | flex-start | flex-end | center | baseline;
//justify-content: $justify-content;
//align-items: $align-items;
 ------ */
.flex {
  display: flex;
  align-items: center;
}

.flex-row {
  display: flex;
  flex-flow: row wrap;
}

.flex-col {
  display: flex;
  flex-flow: column;
  align-items: normal;
}

.hero {
  width: 100%;
  height: 100vh;
}

[class*=-nowrap] {
  flex-wrap: nowrap;
}

[class*=-reverse] {
  flex-direction: row-reverse;
}

[class*=align-start] {
  align-items: flex-start;
}

[class*=align-center] {
  align-items: center;
}

[class*=align-end] {
  align-items: flex-end;
}

[class*=align-stretch] {
  align-items: stretch;
}

[class*=justify-start] {
  justify-content: flex-end;
}

[class*=justify-center] {
  justify-content: center;
}

[class*=justify-end] {
  justify-content: flex-end;
}

[class*=space-between] {
  justify-content: space-between;
}

[class*=space-around] {
  justify-content: space-around;
}

[class*=grow] {
  flex: 1;
}

[class*=first] {
  order: -1;
}

[class*=last] {
  order: 1;
}


.flex-margin-right {
  margin-right: 10px;
}

.tab-list {
  border-bottom: 1px solid $border-color;
}

.tab-item {
  padding: 16px;
  color: $text-color-med;
  border-right: 1px solid $border-color;
  display: inline-block;
  position: relative;

  &.right {
    float: right;
    border-right: none;
    border-left: 1px solid $border-color;
  }

  &.disabled {
    cursor: default !important;
    background-color: $input-background-disabled !important;
    color: $text-color-dark !important;
  }

  &.no-border {
    border: none;
  }

}

.tab-item:hover {
  cursor: pointer;
  background-color: #354253;
}

.pagination {
  width: max-content;

  .page_item {
    display: inline-block;
    padding: 0 5px;
    cursor: pointer;
    color: $text-color-med;

    &:hover {
      color: $text-color-light;
    }

    &.active {
      color: $link-color;
      border-bottom: 1px solid $link-color;
      font-weight: bolder;
      cursor: default;
    }

  }

}

#smart-table-row-selector {
  width: max-content;
}

select {
  border-radius: $border-radius;
  background-color: $input-background;
  border: none;
  padding: 4px 0 4px 4px;
  outline: none;
  color: $text-color-light;
  cursor: pointer;
}

.meta-actions {
  margin-bottom: 20px;

  small {
    color: $text-color-dark;
    margin-right: 8px;
  }

  .highlight {
    color: $text-color-med;
  }
}

table#smart-table-element > tr.clickable:hover {
  background-color: $table-row-clickable-background-hover;
  cursor: pointer;
}

table tr td.clickable, table tr td i {
  cursor: pointer;
  text-align: center;
  color: #48596f;
}

table tr td.clickable i:hover, table tr td i:hover {
  color: $text-color-med;
}

table tr.editing td.clickable i {
  color: $text-color-med;
}

table tr.editing td.clickable i:hover {
  color: $text-color-light;
}

table tr.deleting td.clickable i {
  color: #ff9371;
}

table tr.deleting td.clickable i:hover {
  color: #ffd8cb;
}

table#smart-table-element .actions {
  //box-shadow: 2px 0 0px rgba(0,0,0,0.3);
}

table#smart-table-element > th {
  position: sticky;
  top: 0;
}

th {
  white-space: nowrap;
}

.actions {
  text-align: center;

  small {
    font-weight: 200;
  }
}

table#smart-table-element > tr > td.actions, table#smart-table-element > tr > th.actions {
  position: sticky;
  left: 0;
  background: #0f1117;
  padding: 0 8px;
}

table#smart-table-element > tr.editing > td.actions {
  background-color: $table-row-editing;
}

table#smart-table-element > tr.deleting > td.actions {
  background-color: #e05125;
}

.modal-container {
  position: fixed;
  top: 0;
  right: 0;
  left: 0;
  bottom: 0;
  z-index: 99;
  background-color: rgba(27, 29, 38, 0.94);

  .modal-window {
    margin: 0 auto;
    background-color: $background-color;
    padding: 20px;
    border: 1px solid $border-color;
    max-width: 420pt;
    width: 40vw;
    min-width: 120px;

    h1:first-child, h2:first-child, h3:first-child, h4:first-child {
      margin-top: 0;
    }

    h1:last-child, h2:last-child, h3:last-child, h4:last-child {
      margin-bottom: 0;
    }

    &.wide {
      max-width: 720pt;
      width: 70vw;
      min-width: 120px;
    }
  }
}

.noselect {
  -webkit-touch-callout: none; /* iOS Safari */
  -webkit-user-select: none; /* Safari */
  -khtml-user-select: none; /* Konqueror HTML */
  -moz-user-select: none; /* Old versions of Firefox */
  -ms-user-select: none; /* Internet Explorer/Edge */
  user-select: none; /* Non-prefixed version, currently supported by Chrome, Edge, Opera and Firefox */
}

footer {
  font-size: 10pt;
  position: fixed;
  bottom: 0;
  left: 0;
  right: 0;
  padding: 0 16px;

  .right {
    float: right;
  }
}

#connection_status {
  &:hover .tooltip {
    display: block;
  }

  .tooltip {
    display: none;
    color: #fff;
    background-color: #e25353;
    margin-top: -3.5em;
    position: absolute;
    z-index: 1000;
    font-size: 10pt;
    padding: 2px 4px;
  }
}

.pill {
  padding: 4px;
  border-radius: 0 0 0 4px;
  background-color: #e25353;
  color: white;
  position: absolute;
  right: 0;
  top: 0;
  font-size: 7px;
  font-family: monospace;

  &:empty {
    display: none;
  }
}

.recent-connection {
  width: 340px;
  overflow-x: hidden;
  align-self: stretch;
  display: block;
  border-right: 1px solid $border-color;
  padding: 20px;

  .item:hover .tooltip {
    display: block;
  }

  .tooltip {
    display: none;
    color: #fff;
    background-color: $text-color-dark;
    margin-left: 280px;
    position: absolute;
    z-index: 1000;
    font-size: 10pt;
    padding: 2px 4px;
  }

  .remove {
    float: right;
    color: #48596f;
  }

  .remove:hover {
    color: #e25353;
  }
}


.connection-status {
  font-size: 7pt;
  color: $text-color-light;
  border-bottom: 1px solid $border-color;
  padding: 2px 0;

  &:before {
    width: 9px;
    top: 1px;
    height: 9px;
    border-radius: 10px;
    content: "";
    margin: 0 4px 0 8px;
    position: relative;
    display: inline-block;
  }

  &.retry {
    &:before {
      background-color: #eef131;
      box-shadow: 0 0 6px #eef131;
    }
  }

  &.disconnected {
    &:before {
      background-color: $text-color-error;
      box-shadow: 0 0 6px $text-color-error;
    }
  }

  &.connected {
    &:before {
      background-color: #34d053;
      box-shadow: 0 0 6px #34d053;
    }
  }

}


input[type="checkbox"] {
  position: relative;
  z-index: 1;
  opacity: 0;
  cursor: pointer;
  margin: 0;
  margin-right: 5px;
  visibility: hidden;
  height: 0;
  padding: 0;
}

.input-checkbox-icon {
  position: relative;
}

.input-checkbox-icon:before {
  font-family: 'Font Awesome 5 Free';
  position: absolute;
  left: -1.1rem;
  top: 1px;
  z-index: 0;
  content: "\f0c8";
}

input[type="checkbox"]:checked + .input-checkbox-icon:before {
  font-family: 'Font Awesome 5 Free';
  color: #27a8df;
  content: "\f14a";
}

/* width */
::-webkit-scrollbar {
  width: 10px;
  height: 10px;
}

/* Track */
::-webkit-scrollbar-track {
  background: $background-color-dark;
}

/* Handle */
::-webkit-scrollbar-thumb {
  background: $text-color-dark;
}

/* Handle on hover */
::-webkit-scrollbar-thumb:hover {
  background: $text-color-med;
}

body.not-connected .connected-only {
  cursor: default !important;
  background-color: $input-background-disabled !important;
  color: $text-color-dark !important;
  pointer-events: none;
}